/*
 *  linux/drivers/block/jornada720.c
 *
 */

#undef REALLY_SLOW_IO		/* most systems can safely undef this */

#include <linux/config.h>
#include <linux/module.h>
#include <linux/types.h>
#include <linux/string.h>
#include <linux/kernel.h>
#include <linux/timer.h>
#include <linux/mm.h>
#include <linux/interrupt.h>
#include <linux/major.h>
#include <linux/errno.h>
#include <linux/genhd.h>
#include <linux/malloc.h>
#include <linux/pci.h>
#include <linux/delay.h>

#include <asm/byteorder.h>
#include <asm/irq.h>
#include <asm/uaccess.h>
#include <asm/io.h>
#include <asm/bitops.h>

#ifdef CONFIG_KMOD
#include <linux/kmod.h>
#endif /* CONFIG_KMOD */

void jcaoutb(long p, unsigned char data)
{
		printk("jcaoutb(%lx, %x): stub\n", p, data);
}

unsigned char jcainb(long p)
{
		printk("jcainb(%lx): stub\n", p);
	return 0;
}

#define WritePort32(port,value) (port = (value))
#define ReadPort32(port) (port)

static void ComInit(void)
{
static int initprintf_flag = 0;
if (!initprintf_flag) {
	initprintf_flag = 1;
	WritePort32(ICMR, 0x00000000);	// disables all interrupts which kills the Angel serial interrupt
	WritePort32(Ser3UTCR3, 0x00);	/* disable tx and rx bits and interrupts */
	WritePort32(Ser3UTSR0, 0xFF);	/* clear */
	WritePort32(Ser3UTCR0, 0x08);	/* 8 bit, no parity, 1 stop */
	WritePort32(Ser3UTCR1, 0x00);	/* upper baud rate select */
#define BAUD_115200                     0x001
#define BAUD_38400                      0x005
#define BAUD_19200                      0x00b
#define BAUD_9600                       0x017
#define BAUD_2400                       0x05F 
	WritePort32(Ser3UTCR2, BAUD_115200);
	WritePort32(Ser3UTCR3, 0x03);	/* enable rx and tx */
}
} 
int ComCheckByte(void)
{
    return ReadPort32(Ser3UTSR1) & UTSR1_RNE;
}
unsigned char ComReadByte(void)
{
	return ReadPort32(Ser3UTDR);
}
static void ComPutByte(unsigned char ch)
{
	ComInit();
	while (!(ReadPort32(Ser3UTSR1) & UTSR1_TNF)) ;	/* wait until ready */
	WritePort32(Ser3UTDR, ch);
}
void ComPutChar(unsigned char ch)
{
	if (ch == '\n')
		ComPutByte('\r');
	ComPutByte(ch);
}
void memdump(unsigned char *p, int len, char *title)
{
int i;

    i = 0;
    while (len > 0) {
		if ((i & 0xf) == 0) {
	    	if (i > 0)
				printk("\n");
	    	printk("%s: ",title);
		}
		printk("%02x ", *p++);
		i++;
		len--;
    }
    printk("\n");
}

int ioptrace = 0;
int bops_readb(unsigned char *r)
{
int data = 0;
#if 0
data = *r;
#endif
printk("bops_readb(%p)=%x\n", r, data);
return data;
}
int bops_readl(int r)
{
printk("bops_readl: %x (%x)\n", (int)__builtin_return_address(0), r);
return -1;
}
int bops_writeb(char value, char *place)
{
*place = value;
printk("bops_writeb: %x (%x, %p)\n", __builtin_return_address(0), value, place);
return 0;
}
void jcatracebozo()
{
__backtrace();
return;
}
