/*
 * $Id: cfi_endian.h,v 1.1 2001/01/11 20:05:02 jamey Exp $
 *
 * It seems that some helpful people decided to make life easier
 * for software engineers who aren't capable of dealing with the 
 * concept of byteswapping, and advise engineers to swap the bytes
 * by wiring the data lines up to flash chips from BE hosts backwards.
 *
 * So we have ugly stuff here to disable the byteswapping where necessary.
 * I'm not going to try to do this dynamically.
 *
 * Cheers, guys.
 *
 */

#include <asm/byteorder.h>

#define CFI_LITTLE_ENDIAN
/* #define CFI_HOST_ENDIAN */
/* #define CFI_BIG_ENDIAN */

#if defined(CFI_LITTLE_ENDIAN)
#define cpu_to_cfi16(x) cpu_to_le16(x)
#define cpu_to_cfi32(x) cpu_to_le32(x)
#define cfi16_to_cpu(x) le16_to_cpu(x)
#define cfi32_to_cpu(x) le32_to_cpu(x)
#elif defined (CFI_BIG_ENDIAN)
#define cpu_to_cfi16(x) cpu_to_be16(x)
#define cpu_to_cfi32(x) cpu_to_be32(x)
#define cfi16_to_cpu(x) be16_to_cpu(x)
#define cfi32_to_cpu(x) be32_to_cpu(x)
#elif defined (CFI_HOST_ENDIAN)
#define cpu_to_cfi16(x) (x)
#define cpu_to_cfi32(x) (x)
#define cfi16_to_cpu(x) (x)
#define cfi32_to_cpu(x) (x)
#else
#error No CFI endianness defined
#endif
